% bifurcation diagram for logistic map
% x_{n+1} = (1+a)x_n -ax^2


function bifur_logistic(x0, N1, N2)

% x_0 initial value
% N1 # parameter values
% N2 # iterations
% N3 precision

figure;
xlim([0 3])
xlabel('parameter a')
ylabel('attractor value')
hold on

a = linspace(0,3,N1+1); % parameter space
a = a(2:N1+1); % initialise on first nonzero number

for i = 1:N1 % loop over parameters
    
    x = zeros(1,N2+1);
    x(1) = x0;
    
    for j=1:N2 % loop over iterations
        x(j+1) = (1+a(i))*x(j) - a(i)*x(j)^2;
    end
    
    % find attractors
    
    %str = num2str(X, N3);
    %x = str2num('str');
    
    N3=500;
    a_rep = repmat(a(i),1,N3+1);
    plot(a_rep,x(N2-N3:N2),'.','MarkerSize',2,'Color','k')
    
end

return

%Example

x0=0.5;
N1 = 1000;
N2 = 1000;

bifur_logistic(x0, N1, N2)